#ifndef  __GRDSYSTRAY
#define  __GRDSYSTRAY

#include <windows.h>
#include "grdSysTraySettings.h"
#include "grdIconsWrapper.h"
#include "grdShellTray.h"

// name of shelldesktop class
#define WC_SHELLDESKTOP    TEXT("DesktopBackgroundClass")

// name of the grdSysTray class
#define WC_SYSTRAY         TEXT("grdSysTray")

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* * CLASS: grdSysTray                                       * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* *                                                         * */
/* *  this is the main class, which does all the real work   * */
/* *  it initializes a couple of "sub-classes" that are      * */
/* *  that just to make it easier to understand and manage   * */
/* *  other than that grdTray is a really great LoadModule   * */
/* *                                                         * */
/* *                                      // Gustav Munkby   * */
/* *                                                         * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

class grdSysTray {

	public:

		// this starts the whole thing
		grdSysTray( HWND lswnd, HINSTANCE lsinstance, LPCTSTR lspath );
		// this terminates the whole thing
		~grdSysTray();

	private:

		static LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
		LRESULT WindowProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

		char			   *szLSPath;

		grdSysTraySettings *settings;
		grdIconsWrapper    *icons;
		grdShellTray       *shellTray;

		HINSTANCE           hInstance;

		HWND                hLiteStep;
		HWND				hDesktop;
		HWND				hSysTray;

};


#endif// __GRDSYSTRAY